' Jeremy Sullivan
' 4D Inc.

Option Explicit

Dim objFSO
Dim oShell
Dim nError
Dim iTunesApp
Dim tracks
Dim pathToParentDirectory
Dim index
Dim track
Dim albumName
Dim artistName
Dim skip
Dim i
Dim coverArt
Dim cover
Dim extension
Dim coverFormat
Dim path

' Get our parent objects
Set objFSO = CreateObject("Scripting.FileSYstemObject")
Set oShell = CreateObject("Wscript.Shell")
' Run iTunes hidden
nError = oShell.Run("iTunes", 0)
Set iTunesApp = WScript.CreateObject("iTunes.Application")

' Get all the items from the library
Set tracks = iTunesApp.LibraryPlaylist.tracks

' Get the path to our containing directory
pathToParentDirectory = objFSO.GetParentFolderName(WScript.ScriptFullName)

index = 0
' Have to Deim and then ReDim
Dim processed()
ReDim processed(tracks.Count) ' Holds skip info so we don't get the same art repeatedly

' Loop through all of the tracks
    For Each track In tracks
        albumName = track.Album
        artistName = track.Artist
        skip = False

        ' We only need to get the album art once
        For i=0 to index
            If processed(i) = (albumName & artistName) Then
                skip = True
                Exit For
            End If
        Next

		If Not skip Then
			Set coverArt = track.Artwork
			
			If Not IsNull(coverArt) Then
				' Add it to our skip list
				processed(index) = (albumName & artistName)
				index = index + 1

				For Each cover In coverArt ' should really only be 1
					extension = ".jpg" ' default extension
					coverFormat = cover.Format
			
					If (coverFormat = "PNG") then
						extension = ".png"
					End If
			
					If (coverFormat = "BMP") then
						extension = ".bmp"
					End If
			
					' Remove all the baddies
					ReplaceAllByExpression artistName, "/|\\|:|\*|\?|\<|\>|\|", "_"
					ReplaceAllByExpression albumName, "/|\\|:|\*|\?|\<|\>|\|", "_"

					' Save the artwork to a file
					path = objFSO.BuildPath(pathToParentDirectory, artistName & "_" & albumName & extension)
					If Not objFSO.FileExists(path) Then
						cover.SaveArtworkToFile(path )
					End If
			
				Next
			
			End If

		End If
		
	Next

iTunesApp.Quit

' Replace all matches in the string with the replacement text
Sub ReplaceAllByExpression(ByRef StringToExtract, ByVal MatchPattern, ByVal ReplacementText)
    Dim regEx, CurrentMatch, CurrentMatches

    Set regEx = New RegExp
    regEx.Pattern = MatchPattern
    regEx.IgnoreCase = True
    regEx.Global = True
    regEx.MultiLine = True
    StringToExtract = regEx.Replace(StringToExtract, ReplacementText)
    Set regEx = Nothing
End Sub
